/*
 * Buffer.cpp
 *
 *	  Author: Skia
 */

#include "Buffer.h"

#include <iostream>
#include <stdlib.h>
#include <string.h>

char *strAppend(char *str, char c)
{
    int l = 0;
    char *tmp = NULL;

    if(str != NULL)
        l = strlen(str);

    if((tmp = new char[l*sizeof(char)+2*sizeof(char)]) == NULL)
        return NULL;

    strncpy(tmp, str, l);
    tmp[l++] = c;
    tmp[l] = '\0';

    delete[] str;

    return tmp;
}


Buffer::Buffer( char *fn ) {
	col = row = 1;
	pos = lexemSize = 0;
	f.open(fn);
	if (!f) {
        printf("file couldn't be opened\n");
        exit(1);
    };

	lexem = new char[42];
	setNewLexem();
}

Buffer::~Buffer() {
	delete[] lexem;
	f.close();
}

char Buffer::getChar() {
    char c = 0;
    if (!f.eof()) {
        f.get(c);
        if (c == '\n') {
            col = 1;
            row++;
        } else {
            col++;
            if (!isspace(c)) {
                lexem = strAppend(lexem, c);
                lexemSize++;
            }
        }
        pos++;
        return c;
    } else {
        return EOF_ENCODING;
    }
}

void Buffer::unGetChar(int l) {
    int len = (l > pos) ? pos : l;
    int i;
    char c;

    pos = pos-len;
    f.seekg(-len, std::ios::cur);
    col -= len;
    for (i = 0; i < len; i++) {
        bool nl = false;
        f.get(c);
        if (c == '\n') {
            nl = true;
            col = 1;
            row++;
        } else if (nl) {
            col++;
        }
    }
    f.seekg(-len, std::ios::cur);
    lexemSize -= len;
    lexem[lexemSize] = '\0';
}

char* Buffer::getLexem() {
    return lexem;
}

int Buffer::getColumn() {
    return lexemCol;
}

int Buffer::getRow() {
    return lexemRow;
}
void Buffer::setNewLexem() {
    for (int i = 0; i <= lexemSize; i++) {
        lexem[i] = '\0';
    }
    lexemSize = 0;
    lexemCol = col;
    lexemRow = row;
}

int Buffer::getLexemSize() {
    return lexemSize;
}


