/*
 * Buffer.cpp
 *
 *      Author: tom
 */

#include "Buffer.h"
#include <iostream>
#include <sys/time.h> // TODO remove me later

Buffer::Buffer( char *f ) {
	col = row = 0;
    endFileReached = false;
	posix_memalign((void**) &C, 4096, 8192); // Why don't use that: C = (char*) malloc(8192*sizeof(char)); ?
                                                // It is in slides to use this instead of malloc. I don't think
                                                // it makes significant difference, does it? One thing i wanted
                                                // to ask Prof ...
	//fd = open(f, O_RDONLY, O_DIRECT);
    fd = open( f, O_RDONLY | O_DIRECT );
    readFileNextBlock();
	lexem = new char[8192];
	setNewLexem();
}

Buffer::~Buffer() {
    delete[] lexem;
    delete[] C;
    close(fd);
}

int Buffer::readFileNextBlock ()
{
    int i = 0, ret;
    struct timeval start, end; // TODO remove me later
	if (fd == -1) {
		printf("Error opening the file.\n");
        return -1;
    } else {
        gettimeofday(&start, NULL); // TODO remove me later
        for (i=0;i<8192 && (ret=read(fd, &C[i], 1) > 0);i++) ;
        //ret = read( fd, C, 8192 ); // TODO remove me later   // uncomment this line to make comparison with line above
        gettimeofday(&end, NULL); // TODO remove me later

        // TODO remove me later
        printf("%ld\n", ((end.tv_sec * 1000000 + end.tv_usec) - (start.tv_sec * 1000000 + start.tv_usec)));

        C[i+1] = '\0';

        if (ret == 1)
            endFileReached = false;
        else
            endFileReached = true;
        //std::cout << "File: " << C << std::endl;
        pos = 0;

        return i;
    }

}

char Buffer::getChar() {
    if (C[pos] != '\0') {
        if (C[pos] == '\n') { //check if new line
            col = 0;
            row++;
        } else {
            col++;
            if (!isspace(C[pos]))
                lexem[lexemPos++] = C[pos];
        }
        pos++;
        return C[pos-1];
    } else if (!endFileReached) {
        readFileNextBlock();
        return getChar();
    } else {
        return -1;
    }
}

void Buffer::unGetChar(int len) {
    int h;
    for (h = pos; h > (pos - len); h--) { //go back char by char
        if (C[h] == '\n') { //if line break
            row--;
            col = 0;
            int l = pos;
            while ((C[l] != '\n') && (l != 0)) { //find out new col by getting dist.
                col++;			      //from line end to next break line
                l--;
            }
        } else {
            col--;
        }
    }
    pos -= len;
    int l;
    for (l = lexemPos; l > (lexemPos - len); l--) {	//go back (delete chars) in lexem
        lexem[l] = '\0';
    }
    lexemPos -= len;
}

char* Buffer::getLexem() {
    return lexem;
}

int Buffer::getColumn() {
    return col;
}

int Buffer::getRow() {
    return row;
}
void Buffer::setNewLexem() {
    int j;
    for (j = 0; j <= lexemPos; j++) { //completely delete old lexem
        lexem[j] = '\0';
    }
    lexemPos = 0;
    if (!isspace(C[pos]))
        lexem[lexemPos++] = C[pos]; //new lexem
}


