/*
 * Parser definition file
 *
 * Author: Skia
 * Date: 31 May 2014
 *
 */

#include <iostream>
#include <fstream>
#include <Parser.h>
#include <TList.h>
#include <Token.h>


void printTokenType( TokenType t );

Parser::Parser(Scanner *s)
{
    this->sc = s;
}

bool Parser::parse()
{
    return prog();
}

void Parser::error(Token *t = NULL, char *msg = (char*)"Troll")
{
    std::cout << "Error: Unexpected Token ";
    t->pInfo(std::cout);
    std::cout << std::endl;
    delete t;
    exit(EXIT_FAILURE);
}

bool Parser::prog()
{
    return decls(); // && statments();
}

bool Parser::decls()
{
    /* JUST A TRY, CAN BE REMOVED IF WE FIND BETTER */

    List *l = new List();
    int max = 6;
    Token *t = NULL;
    bool finished = false;
    LItem *it = NULL;

    do {
        while (l->getSize() < max && (t = this->sc->nextToken())->getTokenType() != T_SEMICOLON) {
            l->push(t);
        }
        std::cout << std::endl << "List: " << std::endl;
        it = l->head();
        while (it != NULL) {
            it->t->pType(std::cout);
            std::cout << std::endl;
            it = it->n;
        }
        if (l->getSize() >= max) {
            delete l;
            return false;
        }
        finished = !decl(l);
    } while (!finished);

    l->clean();
    delete l;

    return false;
}

// TODO: Improve that a lot to really return what could be a possible unexpected token:
// always check the size of the list, and the tokens one by one, not every thing in one test!
// Handle array and declaration in general
bool Parser::decl(List *l)
{
    Token *first = l->rem(),
          *last = l->pop();
    // std::cout << "Size: " << l->getSize() << std::endl;
    if (first->getTokenType() == T_INT) {
        if (last->getTokenType() == T_IDENTIFIER) {
            if (l->head() != NULL)
                array(l);
            // TODO: add the var to the dcl tree
            delete first;
            delete last;
            return true;
        } else {
            delete first;
            error(last);
        }
    } else {
        delete last;
        error(first);
    }
    return false;
}

// IDEA: array returns the size of the array, to build the tree
int Parser::array(List *l)
{
    int value = 0;
    Token *lb = l->rem(),
          *in = l->rem(),
          *rb = l->rem();
    if (lb->getTokenType() == T_LBRACKET) {
        if (in->getTokenType() == T_INTEGER) {
            if (rb->getTokenType() == T_RBRACKET) {
                value = in->getValue();
            } else {
                delete lb;
                delete in;
                error(rb);
            }
        } else {
            delete lb;
            delete rb;
            error(in);
        }
    } else {
        delete rb;
        delete in;
        error(lb);
    }
    delete lb;
    delete in;
    delete rb;
    return value;
}



