/*
 *
 * cpp file for the token linked list
 *
 * Author: Skia
 * Date: 31 May 2014
 */
#include <TList.h>
#include <stdlib.h>
#include <stdio.h>


List::List(): m_head(NULL), m_tail(NULL), m_size(0) {}

List::~List()
{
    this->clean();
}

LItem *List::head()
{
    return m_head;
}

LItem *List::tail()
{
    return m_tail;
}

int List::getSize()
{
    return m_size;
}

void List::add(Token *data)
{
    LItem *i = new LItem();
    i->t = data;
    i->n = m_head;
    i->p = NULL;
    if (m_head != NULL) {
        m_head->p = i;
        m_head = i;
    } else {
        m_head = i;
        m_tail = i;
    }
    m_size++;
}

void List::push(Token *data)
{
    LItem *i = new LItem();
    i->t = data;
    i->n = NULL;
    i->p = m_tail;
    if (m_tail != NULL) {
        m_tail->n = i;
        m_tail = i;
    } else {
        m_head = i;
        m_tail = i;
    }
    m_size++;
}

Token *List::rem()
{
    LItem *i = m_head;
    Token *d = NULL;
    if (m_head != NULL) {
        d = i->t;
        if (m_head->n != NULL) {
            m_head->n->p = NULL;
            m_head = m_head->n;
        } else {
            m_head = m_tail = NULL;
        }
        delete i;
    }
    m_size--;
    return d;
}

Token *List::pop()
{
    LItem *i = m_tail;
    Token *d = NULL;
    if (m_tail != NULL) {
        d = i->t;
        if (m_tail->p != NULL) {
            m_tail->p->n = NULL;
            m_tail = m_tail->p;
        } else {
            m_head = m_tail = NULL;
        }
        delete i;
    }
    m_size--;
    return d;
}

void List::clean()
{
    Token *d = NULL;
    while ((d = rem()) != NULL)
        delete d;
    m_head = m_tail = NULL;
}
