/*
 * Automat.h
 *
 * Template:
 *  Created on: Jul 5, 2012
 *      Author: knad0001
 * Class and overall file:
 *  Created on: Apr 16, 2014
 *      Author: Skia
 */

#ifndef Automat_H_
#define Automat_H_

#include <Token.h>


enum State { // Used for matrix index. Don't change the numbers!
    S_START = 0,
    S_IDENTIFIER,
    S_INTEGER,
    S_SIGN,
    S_EQ,
    S_D_EQ,
    S_T_EQ,
    S_EQ_DIFF,
    S_EQ_DIFF_EQ,
    S_SLASH,
    S_COM,
    S_COM_M,
    S_END,
    S_ERROR,
    NR_OF_STATE
};

enum CharType { // Used for matrix index. Don't change the numbers!
    C_SIGN = 0,
    C_EQ,
    C_DIFF,
    C_SLASH,
    C_STAR,
    C_DIGIT,
    C_LETTER,
    C_SPACE,
    C_UNKNOWN,
    NR_OF_CHAR_TYPE
};

/* Define two string function */
char *strAppend(char *str, char c);
char *strToLower(char *str);



class Automat {
public:
	Automat();
	virtual ~Automat();

    State getState( void ) const;
    TokenType getTokenType( void ) const;
    int getBack( void ) const;

    bool readChar( char c );

private:
    CharType typeOfChar( char c ) const;
    TokenType getSignType( void ) const;

    void setTokenType( void );

    int **buildMatrix( void );


    TokenType m_type;
    State m_state;
    char m_currentChar;
    static const int m_matrix[NR_OF_CHAR_TYPE][NR_OF_STATE];
    int m_back;
};

#endif /* Automat_H_ */


