/*
 * Buffer.h
 *
 *      Author: Skia
 */

#ifndef BUFFER_H_
#define BUFFER_H_

#include <iostream>
#include <fstream>

class Buffer {
public:
	Buffer(char* f);
	virtual ~Buffer();
	char getChar();
	void unGetChar(int len);
	char* getLexem();
	int getColumn();
	int getRow();
	void setNewLexem();
	int getLexemSize();
private:
	int pos;
    std::ifstream f;
	int col;	//column of char
	int row;	//row of char
	char *lexem;
	int lexemPos;
	int lexemSize;
	int lexemCol;	//column where lexem begins
	int lexemRow;	//row where lexem begins
};

#define EOF_ENCODING -1

#endif /* BUFFER_H_ */
