/*
 * Scanner.h
 *
 *  Created on: Sep 26, 2012
 *      Author: knad0001
 *  Class and overall file:
 *  Created on: Apr 19, 2014
 *      Author: mino
 */

#ifndef SCANNER_H_
#define SCANNER_H_

#include <stdlib.h> // for strtol
#include <cerrno> // for errno on integer checks
#include <climits>
#include <cctype>
#include <iostream>

#include <Token.h>
#include <Buffer.h>
#include <Automat.h>
#include <Symboltable.h>

/*
 *
 * Scanner class
 *
 */
class Scanner
{
    public:
        Scanner( char *filepath, Symboltable *symtab );
        virtual ~Scanner();
        Token *nextToken( void );

    private:
        Buffer      *buffer;
        Automat     *automat;
        Symboltable *symtab;

        Token *createToken( TokenType ttype, int row, int column, char *lexem );
        void skipComment( bool multiline );
};

#endif /* SCANNER_H_ */

