/*
 * Symboltable.h
 *
 *  Created on: Sep 26, 2012
 *      Author: knad0001
 */

#ifndef SYMBOLTABLE_H_
#define SYMBOLTABLE_H_

#include <stdlib.h>

// TODO remove these headers later, these are only for testing
#include <iostream>
#include <string>
#include <cstring>

#include <Token.h>

#define PAGE_SIZE 4096
#define STRINGTAB_BUFSIZE 8192

#define NUM_BUCKETS 256




/*
 *
 * StringTab class
 *
 */
class StringTab
{
    public:
        StringTab();
        virtual ~StringTab();
        char *insert( char *lexem, int size );

    private:
        char *space;
        char	*freeP;
        int		freeSpace;
};

/*
 *
 * Information class
 *
 */
class Information
{
    public:
        Information();
        virtual ~Information();
        bool compareLexem( char *lexem ) const;
        char *getName() const;
        TokenType getType( void ) const;
        void setName( char *lexem );
        void setType( TokenType t );

    private:
        char *lexem;
        TokenType type;
};

/*
 *
 * SymtabEntry class
 *
 */
class SymtabEntry
{
    public:
        SymtabEntry();
        virtual ~SymtabEntry();
        SymtabEntry *getNext( void );
        void setNext( SymtabEntry *ste );
        Information *getInfo();

    private:
        SymtabEntry	*next;
        Information info;
};

/*
 *
 * Symboltable class
 *
 */
class Symboltable
{
    public:
        Symboltable();
        virtual ~Symboltable();
        symtabkey_t insert( char *lexem );
        void print( void );

    private:
        StringTab *strTab;
        SymtabEntry	*bucket[256];
        int hash( char *lexem );
        void initSymbols( void );
};



#endif /* SYMBOLTABLE_H_ */

