
#ifndef TOKEN_H
#define TOKEN_H

#include <iostream>

typedef class SymtabEntry *symtabkey_t;

enum TokenType {
    T_PLUS,
    T_MINUS,
    T_DIVIDE,
    T_MULTI,
    T_LESSTHAN,
    T_MORETHAN,
    T_ASSIGN,
    T_EQUAL,
    T_UNEQUAL,
    T_EXCLAMATION,
    T_AND,
    T_SEMICOLON,
    T_LPARENT,
    T_RPARENT,
    T_LBRACKET,
    T_RBRACKET,
    T_LBRACE,
    T_RBRACE,
    T_INTEGER,
    T_IF,
    T_WHILE,
    T_INT,
    T_IDENTIFIER,
    T_COM,
    T_COM_M,
    T_END,
    T_UNKNOWN,
    NR_OF_TOKEN_TYPE
};


/*
 *
 * Token class
 *
 */
class Token
{
    public:
        Token( TokenType ttype, int row, int column, symtabkey_t key, int value );
        virtual ~Token();
        TokenType getTokenType( void ) const;
        int getRow( void ) const;
        int getColumn( void ) const;
        symtabkey_t getKey( void ) const;
        int getValue( void ) const;
        void setTokenType( TokenType ttype );
        void setRow( int row );
        void setColumn( int column );
        void setKey( symtabkey_t key );
        void setValue( int value );
        void pType(std::ostream &s) const;
        void pInfo(std::ostream &s) const;

    private:
        TokenType ttype;
        int row;
        int column;
        symtabkey_t key; // for fast lookup into symboltable
        int value; // if it is integer, the value is stored here
};


void printTokenType( TokenType t );


#endif
